<template>
<div>
    <app-layout>
        <template #header>Role Manager</template>
        <panel>
            <div class="p-6 sm:px-20">
                <div class="relative">
                    <div class="max-w-7xl mx-auto px-4 sm:px-6">
                        <div class="flex justify-between items-center border-b-2 border-gray-100 py-6 md:justify-start md:space-x-10">
                            <div class="lg:w-0 lg:flex-1">
                                <h3 class="font-bold text-xl flex">Roles</h3>
                            </div>
                            <div class="hidden md:flex items-center justify-end space-x-8 md:flex-1 lg:w-0">
                                <span class="inline-flex rounded-md shadow-sm">
                                    <button class="whitespace-no-wrap inline-flex items-center justify-center px-4 py-2 border border-transparent text-base leading-6 font-medium rounded-md text-white bg-green-600 hover:bg-green-500 focus:outline-none focus:border-green-700 focus:shadow-outline-green active:bg-green-700 transition ease-in-out duration-150"
                                        @click="selectedRole = -1; openRoleModal()">
                                        New Role
                                    </button>
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <action-message :on="roleform.recentlySuccessful" class="mr-3 text-green-600">
                    <span v-if="lastRoleChange < 0">Role created successfully</span>
                    <span v-else-if="lastRoleChange !== null && lastRoleChange < roles.length && lastRoleChange > 0">{{ roles[lastRoleChange].name }} was updated successfully</span>
                </action-message>
                <table class="table-auto" v-if="roles.length > 0">
                    <thead>
                        <tr>
                            <th class="px-4 py-2">Name</th>
                            <th class="px-4 py-2">Description</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="(role,i) in roles" :key="role.id" :class="{'bg-yellow-300':selectedRole == i}" class="hover:bg-yellow-200 dark:hover:bg-yellow-500" @click="selectRole(i)">
                            <td class="border px-4 py-2">
                                <feather class="mr-1 h-3 align-middle" type="users" v-if="role.group_linked === true || role.group_linked > 0" />
                                <feather class="mr-1 h-3 align-middle" type="globe" v-else />
                                {{role.name}}
                            </td>
                            <td class="border px-4 py-2">{{role.description}}</td>
                        </tr>
                    </tbody>
                </table>
                <div v-else>
                    No Roles
                </div>
            </div>
        </panel>
    </app-layout>
    <dialog-modal :show="roleModalOpen" @close="closeRoleModal">
        <template #title>
            <span v-if="selectedRole < 0">New Role</span>
            <span v-else>Edit {{ selected.name }}</span>
        </template>
        <div class="mb-4">
            <input-error :message="roleform.error('name')" class="mt-2 text-red-600" />
            <x-label class="mb-2">Name</x-label>
            <x-input v-model="roleform.name" placeholder="My Role" class="w-full py-2 px-3"/>
        </div>
        <div class="mb-4">
            <input-error :message="roleform.error('description')" class="mt-2 text-red-600" />
            <x-label class="mb-2">Description</x-label>
            <x-input v-model="roleform.description" class="w-full py-2 px-3 text-gray-700"/>
        </div>
        <div class="mb-4">
            <input-error :message="roleform.error('permissions')" class="mt-2 text-red-600" />
            <x-label class="mb-2">Permissions</x-label>
            <x-input v-model="roleform.permissions" placeholder="read-anything write-anything" class="w-full py-2 px-3"/>
            <div class="block text-gray-600 text-sm mt-1">Please separate permissions by a space</div>
            <!-- TODO: Autocomplete using permissions (depending on role) -->
        </div>
        <div class="mb-4"> 
            <input-error :message="roleform.error('group')" class="mt-2 text-red-600" />
            <input type="checkbox" v-model="roleform.group" class="shadow border rounded py-2 px-3 text-gray-700 dark:text-gray-300 leading-tight focus:outline-none focus:shadow-outline"/>
            <label class="text-gray-700 text-sm font-bold mb-2">Group Role</label>
            <!-- TODO: Check permissions when switching roles. -->
        </div>
        <template #footer>
            <danger-button @click.native.prevent="closeRoleModal"><feather type="x-octagon" class="h-3 mr-px text-red-200 align-middle" /> Cancel</danger-button>
            <danger-button class="ml-2" @click.native.prevent="deleteRole" v-if="selectedRole >= 0"><feather type="trash" class="h-3 mr-px text-gray-800 align-middle" /> Delete</danger-button>
            <x-button class="ml-2" @click.native.prevent="createRole" >
                <span v-if="selectedRole < 0"><feather type="plus-circle" class="h-3 mr-px text-green-400 align-middle" /> Create</span>
                <span v-else><feather type="thumbs-up" class="h-3 mr-pxtext-green-400 align-middle" /> Update</span>
            </x-button>
        </template>
    </dialog-modal>
</div>
</template>

<script>

    export default {
        props: {
            roles: {
                type: Array,
                required: true,
            },
            permissions: { // autocomplete
                type: Object,
                default: [],
            },
        },
        data(){
            return {
                roleform: this.$inertia.form({
                    id: this.id,
                    name: this.name,
                    description: this.description,
                    permissions: this.permissions,
                    group: this.group,
                }, {
                    bag: 'roles',
                    resetOnSuccess: true,
                }),
                roleModalOpen: false,
                selectedRole: -1,
                lastRoleChange: null,
            }
        },
        computed: {
            selected(){
                if(this.selectedRole >= 0) return this.roles[this.selectedRole];
                return {};
            },
        },
        methods:{
            createRole() {
                this.lastRoleChange = this.selectedRole;
                if(this.selectedRole < 0) this.roleform.post('/roles',{
                    preserveScroll: true,
                });
                else this.roleform.put('/roles/' + this.roleform.id,{
                    preserveScroll: true,
                    onSuccess: ()=>{
                        this.selectedRole = -1;
                    },
                });
                this.roleModalOpen = false;
            },
            selectRole(id) {
                this.selectedRole = id;
                this.openRoleModal();
            },
            deleteRole(){
                if(this.selectedRole < 0) return;
                if(!confirm("Are you sure you want to delete the role, " + this.selected.name + "?")) return;
                this.roleform.delete('/roles/' + this.roleform.id);
                this.roleModalOpen = false;
            },
            openRoleModal(){
                if(this.selectedRole < 0 && this.roleform.id !== null) {
                    this.roleform.id = null;
                    this.roleform.name = '';
                    this.roleform.description = '';
                    this.roleform.permissions = '';
                    this.roleform.group = false;
                } else {
                    this.roleform.id = this.selected.id;
                    this.roleform.name = this.selected.name;
                    this.roleform.description = this.selected.description;
                    this.roleform.permissions = this.selected.permissions;
                    this.roleform.group = this.selected.group_linked > 0; // true|1 > 0
                }
                this.roleModalOpen = true;
            },
            closeRoleModal(){
                this.selectedRole = -1;
                this.roleModalOpen = false;
            },
        },
    }
</script>